//------------------------------------------------------------------
#property copyright "mladen"
#property link      "mladenfx@gmail.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1  DeepSkyBlue
#property indicator_width1  2
#property indicator_minimum 0
#property indicator_maximum 100

//
//
//
//
//

extern string Symbol1          = "";
extern string Symbol2          = "";
extern int    Price            = PRICE_CLOSE;
extern int    StochasticLength = 55;
extern int    SmoothEMA        = 15;

double dssBuffer[];
string indicatorFileName;
bool   returnBars;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,dssBuffer);
      StochasticLength  = MathMax(1,StochasticLength);
      SmoothEMA         = MathMax(1,SmoothEMA);
      indicatorFileName = WindowExpertName();
      returnBars        = (Symbol1=="returnBars"); if (returnBars) return(0);
         if (Symbol1=="") Symbol1=Symbol();
         if (Symbol2=="") Symbol2=Symbol();
   IndicatorShortName("DSS Bressert of "+Symbol1+" to "+Symbol2+" difference ("+StochasticLength+","+SmoothEMA+")");
   return(0);
}
int deinit(){ return(0); }


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars = IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars > 0) counted_bars--;
           int limit = MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { dssBuffer[0] = limit+1; return(0); }
           if (Symbol1!=Symbol()) limit = MathMax(limit,MathMin(Bars-1,iCustom(Symbol1,0,indicatorFileName,"returnBars",0,0)));
           if (Symbol2!=Symbol()) limit = MathMax(limit,MathMin(Bars-1,iCustom(Symbol2,0,indicatorFileName,"returnBars",0,0)));

   //
   //
   //
   //
   //
   
 	for(int i = limit; i>=0; i--)
 	{
      int y = iBarShift(Symbol1,0,Time[i]); double price1 = iMA(Symbol1,0,1,0,MODE_SMA,Price,y);
          y = iBarShift(Symbol2,0,Time[i]); double price2 = iMA(Symbol2,0,1,0,MODE_SMA,Price,y);
          double difference = 0;
               if (price2!=0) difference = price1/price2;
          dssBuffer[i] = iDss(difference,difference,difference,StochasticLength,SmoothEMA,i);
   } 	    
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workDss[][5];
#define _st1    0
#define _ss1    1
#define _pHigh  2
#define _pLow   3
#define _dss    4

double iDss(double close, double high, double low, int length, double smooth, int r)
{
   if (ArrayRange(workDss,0)!=Bars) ArrayResize(workDss,Bars); r=Bars-r-1;
   
   //
   //
   //
   //
   //
   
      double alpha = 2.0 / (1.0+smooth);
         workDss[r][_pHigh]  = high;
         workDss[r][_pLow]   = low;
     
         double min = workDss[r][_pLow];
         double max = workDss[r][_pHigh];
         for (int k=1; k<length && (r-k)>=0; k++)
         {
            min = MathMin(min,workDss[r-k][_pLow]);
            max = MathMax(max,workDss[r-k][_pHigh]);
         }
      
         workDss[r][_st1] = 0;
               if (min!=max) workDss[r][_st1] = 100*(close-min)/(max-min);
         workDss[r][_ss1] = workDss[r-1][_ss1]+alpha*(workDss[r][_st1]-workDss[r-1][_ss1]);

         //
         //
         //
         //
         //
         
         min = workDss[r][_ss1];
         max = workDss[r][_ss1];
         for (k=1; k<length && (r-k)>=0; k++)
         {
            min = MathMin(min,workDss[r-k][_ss1]);
            max = MathMax(max,workDss[r-k][_ss1]);
         }
         double stoch = 0; if (min!=max) stoch = 100*(workDss[r][_ss1]-min)/(max-min);
         
         //
         //
         //
         //
         //
         
         workDss[r][_dss] = workDss[r-1][_dss]+alpha*(stoch -workDss[r-1][_dss]);
   return(workDss[r][_dss]);
}

